# This is the Kernel entry point
# At this point, GDT should be set up and we should be in protected mode

.section .start
.text
.global start
.code32
.org 0x0
kernel_start:
	# Set up Segment Registers
	movw $0x0010, %ax
	movw %ax, %ds
	movw %ax, %es
	movw %ax, %fs
	movw %ax, %gs
	movw %ax, %ss

	call k_install_paging	# Install initial page dir and table

	# Set up kernel stack
	movl $0x00FFFFFF, %ebp	# Stack starts at 16MB
	movl $0x00FFFFFF, %esp

	jmp HigherHalf

HigherHalf:
	call k_main

hang:
	jmp hang

# Include the ISR and IRQ stubs
.include "boot/interrupts.inc"
