/*
	ASM macro definitions
*/
#define ASM_H 1

#define cli() __asm__ ("cli\n\t")
#define sti() __asm__ __volatile__ ("sti\n\t")

#define halt() __asm__ ("cli;hlt\n\t")
#define idle() __asm__ ("jmp .\n\t")

#define inb(port) (__extension__({ unsigned char __res; __asm__ ("inb %%dx, %%al\n\t" : "=a" (__res) : "dx" (port)); __res;}))
#define outb(value, port) __asm__ ( "outb %%al, %%dx\n\t"::"al" (value), "dx" (port))

#define insl(port, buf, nr) __asm__ ("cld;rep;insl\n\t"::"d" (port), "D" (buf), "c" (nr))
#define outsl(buf, nr, port) __asm__ ("cld;rep;outsl\n\t"::"d" (port), "S" (buf), "c" (nr))

#define set_gdt_loc(gdt_reg) __asm__ ("lgdt (%0)\n\t":: "r" (gdt_reg))
#define set_idt_loc(idt_reg) __asm__ ("lidt (%0)\n\t":: "r" (idt_reg))
#define set_tr(tr_loc) __asm__("ltr %0\n\t":: "r" (tr_loc))

#define READ_CR0() (__extension__({ unsigned int __res; __asm__ ("movl %%cr0, %%eax\n\t" : "=a" (__res) :); __res;}))
#define WRITE_CR0(value) __asm__ ( "movl %%eax, %%cr0\n\t"::"A" (value))

#define READ_CR3() (__extension__({ unsigned int __res; __asm__ ("movl %%cr3, %%eax\n\t" : "=a" (__res) :); __res;}))
#define WRITE_CR3(value) __asm__ ( "movl %%eax, %%cr3\n\t"::"A" (value))

#define FLUSH_SEGMENTS(value) __asm__("movw %%ax, %%ds\n\tmovw %%ax, %%es\n\tmovw %%ax, %%fs\n\tmovw %%ax, %%gs\n\tmovw %%ax, %%ss\n\t"::"A" (value))
