#include "asm.h"
#include "system.h"
#include "irq.h"
#include "scheduler.h"
#include "keyboard.h"
#include "video.h"

void irq_handler(struct REGS *r)
{
	char * irqID[] = {	"irq0 - Timer", 
				"irq1 - Keyboard", 
				"irq2", 
				"irq3 - COM2", 
				"irq4 - COM1", 
				"irq5 - LPT2", 
				"irq6 - Floppy", 
				"irq7 - LPT1", 
				"irq8 - CMOS Clock", 
				"irq9", 
				"irq10", 
				"irq11", 
				"irq12 - PS2 Mouse", 
				"irq13", 
				"irq14 - IDE0", 
				"irq15 - IDE1"};
	int irq = r->int_no - 32;

	// Call the appropriate handler
	switch(irq) {
		case 0: 		// PIT
			scheduler();
			break;
		case 1:			// Keyboard
			keyboard_handler();
			break;
		default:
			k_scroll();
			k_printf(irqID[irq]);	
	}
	
	if (r->int_no >= 40) {		// Send EOI to slave controller if int > 40
		outb(0x20, 0xA0);
	}
	outb(0x20, 0x20);		// Need to send EOI to master controller regardless
}

