#include "asm.h"
#include "system.h"
#include "keyboard.h"
#include "video.h"

unsigned char shf_p = 0;
unsigned char ctl_p = 0;
unsigned char alt_p = 0;
unsigned char scan_code = 0;
unsigned char keymap[] = {	'.', '.', '1', '2', '3', '4', '5', '6', '7', '8',
				'9', '0', '-', '=', '.', '.', 'q', 'w', 'e', 'r',
				't', 'y', 'u', 'i', 'o', 'p', '[', ']', '.', '.',
				'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';',
				'\'', '`', '.', '\\', 'z', 'x', 'c', 'v', 'b', 'n',
				'm', ',', '.', '/', '.', '.', '.', ' ', '.'};

static void ctl(void)
{
	ctl_p ^= 0x1;
}

static void alt(void)
{
	alt_p ^= 0x1;
}

static void shf(void)
{
	shf_p ^= 0x1;
}

static void fun(void)
{
	k_cls();
}

static void unp(void)
{
}

static void pln(void)
{
	if(scan_code&0x80)
		return;

	switch(scan_code) {
	case 28:
		k_scroll();
		break;
	case 14:
		k_bs();
		break;
	default:
		k_putc(keymap[scan_code]);
		break;
	}
}

void keyboard_handler(void)
{
	int com = 0;
	static void (*key_way[0x80])(void) = {
		unp, unp, pln, pln, pln, pln, pln, pln,
		pln, pln, pln, pln, pln, pln, pln, pln,
		pln, pln, pln, pln, pln, pln, pln, pln,
		pln, pln, pln, pln, pln, ctl, pln, pln,
		pln, pln, pln, pln, pln, pln, pln, pln,
		pln, pln, shf, pln, pln, pln, pln, pln,
		pln, pln, pln, pln, pln, pln, shf, pln,
		alt, pln, unp, fun, fun, fun, fun, fun,
		fun, fun, fun, fun, fun, unp, unp, unp,
		unp, unp, unp, unp, unp, unp, unp, unp,
		unp, unp, unp, unp, unp, unp, unp, fun,
		fun, unp, unp, unp, unp, unp, unp, unp,
		unp, unp, unp, unp, unp, unp, unp, unp,
		unp, unp, unp, unp, unp, unp, unp, unp,
		unp, unp, unp, unp, unp, unp, unp, unp,
		unp, unp, unp, unp, unp, unp, unp, unp,
	};

	scan_code = inb(0x60);
	(*key_way[scan_code&0x7F])();

	outb((com=inb(0x61))|0x80, 0x61);
	outb(com&0x7F, 0x61);
}
