#include "asm.h"
#include "system.h"
#include "paging.h"

/* Initialize paging for kernel */
void k_install_paging(void)
{
	int i = 0;
	unsigned int addr = 0;
	unsigned long *pageDir = (unsigned long *) PAGE_DIR;
	unsigned long *lhPageTable = (unsigned long*) PAGE_TABLE_LH;
	unsigned long *hhPageTable = (unsigned long*) PAGE_TABLE_HH;

	for(i=0;i<1024;i++) {
		pageDir[i] = 0;				// Clear out PDir
	}

	for(i=0;i<4096;i++) {
		lhPageTable[i] = addr | 3;		// Map 1st 16MB of mem
		hhPageTable[i] = addr | 3;
		addr += 4096;
	}

	pageDir[0] = ((unsigned long)lhPageTable) | 3;	// Map first table
	
	for(i=1;i<4;i++) {
		pageDir[i] = pageDir[i-1] + 0x1000;	// Map next 3 tables
	}

	pageDir[512] = ((unsigned long)hhPageTable) | 3;// Map first table

	for(i=513;i<516;i++) {
		pageDir[i] = pageDir[i-1] + 0x1000;	// Map next 3 tables
	}

	WRITE_CR3(pageDir);
	WRITE_CR0(READ_CR0() | 0x80000000);
}

