/*
 * Contains all the support for writing to video buffer
*/
#include "system.h"
#include "video.h"

unsigned int cursorLocation = 0;

void k_print_test(void)
{
	char * hellostr = "The quick brown fox jumps over the lazy dog.";

	k_scroll();	
	k_printf(hellostr);
}

/* Print a null terminated string to video buffer */
void k_printf(char * str)
{
	int i = 0;
	for(i=0; str[i]!='\0'; i++) k_printc(i, 24, 0, 15, str[i]);
}

/* Scroll the video buffer */
void k_scroll(void)
{
	unsigned int* src = (unsigned int *) (VIDEO_BUFFER + 0xA0);
	unsigned int* dst = (unsigned int *) VIDEO_BUFFER;
	unsigned int* end = (unsigned int *) (VIDEO_BUFFER + 0xFA0);
	extern unsigned int cursorLocation;

	while(src < end) *(dst++) = *(src++);		// Scroll up

	src = (unsigned int *) (VIDEO_BUFFER + 0xF00);
	while(src < end) *(src++) = 0x00200000; 	// Blank out the last row

	cursorLocation = 1920;
}

/* Clear the screen */
void k_cls(void)
{
	unsigned int* src = (unsigned int*) VIDEO_BUFFER;
	unsigned int* end = (unsigned int*) (VIDEO_BUFFER + 0xFA0);
	while(src < end) *(src++) = 0x00200000; 	
}

/* Print a character anywhere on the screen */
void k_printc(int x, int y, unsigned char bc, unsigned char fc, unsigned char c)
{
	unsigned short attrib = ((bc << 4) | (fc & 0x0F)) << 8;
	volatile unsigned short *where;
	
	where = (unsigned short *) (VIDEO_BUFFER + ((y*160) + (x*2)));
	*where = (unsigned short) (c | attrib);
}

/* Print a null terminated string to video buffer at cursor */
void k_puts(char * str)
{
	int i = 0;
	for(i=0; str[i]!='\0'; i++) k_putc(str[i]);
	k_scroll();
}

/* Print a character at the cursor */
void k_putc(unsigned char c)
{
	unsigned char bc = 0;
	unsigned char fc = 15;
	unsigned short attrib = ((bc << 4) | (fc & 0x0F)) << 8;
	volatile unsigned short *where;
	extern unsigned int cursorLocation;
	
	if(cursorLocation > 1999) {
		k_scroll();
		cursorLocation = 1920; 
	}

	where = (unsigned short *) (VIDEO_BUFFER +(cursorLocation*2));
	*where = (unsigned short) (c | attrib);

	cursorLocation++;
}

/* delete last character */
void k_bs(void)
{
	extern unsigned int cursorLocation;

	if(cursorLocation > 0) {
		cursorLocation--;
		k_putc(' ');
		cursorLocation--;
	}
}
